Imported Upstream version 1.8.0
[platform/upstream/git.git] / t / perf / perf-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2011 Thomas Rast
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # do the --tee work early; it otherwise confuses our careful
19 # GIT_BUILD_DIR mangling
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 TEST_DIRECTORY=$(pwd)/..
35 TEST_OUTPUT_DIRECTORY=$(pwd)
36 if test -z "$GIT_TEST_INSTALLED"; then
37         perf_results_prefix=
38 else
39         perf_results_prefix=$(printf "%s" "${GIT_TEST_INSTALLED%/bin-wrappers}" | tr -c "[a-zA-Z0-9]" "[_*]")"."
40         # make the tested dir absolute
41         GIT_TEST_INSTALLED=$(cd "$GIT_TEST_INSTALLED" && pwd)
42 fi
43
44 TEST_NO_CREATE_REPO=t
45 TEST_NO_MALLOC_CHECK=t
46
47 . ../test-lib.sh
48
49 # Variables from test-lib that are normally internal to the tests; we
50 # need to export them for test_perf subshells
51 export TEST_DIRECTORY TRASH_DIRECTORY GIT_BUILD_DIR GIT_TEST_CMP
52
53 perf_results_dir=$TEST_OUTPUT_DIRECTORY/test-results
54 mkdir -p "$perf_results_dir"
55 rm -f "$perf_results_dir"/$(basename "$0" .sh).subtests
56
57 if test -z "$GIT_PERF_REPEAT_COUNT"; then
58         GIT_PERF_REPEAT_COUNT=3
59 fi
60 die_if_build_dir_not_repo () {
61         if ! ( cd "$TEST_DIRECTORY/.." &&
62                     git rev-parse --build-dir >/dev/null 2>&1 ); then
63                 error "No $1 defined, and your build directory is not a repo"
64         fi
65 }
66
67 if test -z "$GIT_PERF_REPO"; then
68         die_if_build_dir_not_repo '$GIT_PERF_REPO'
69         GIT_PERF_REPO=$TEST_DIRECTORY/..
70 fi
71 if test -z "$GIT_PERF_LARGE_REPO"; then
72         die_if_build_dir_not_repo '$GIT_PERF_LARGE_REPO'
73         GIT_PERF_LARGE_REPO=$TEST_DIRECTORY/..
74 fi
75
76 test_perf_create_repo_from () {
77         test "$#" = 2 ||
78         error "bug in the test script: not 2 parameters to test-create-repo"
79         repo="$1"
80         source="$2"
81         source_git=$source/$(cd "$source" && git rev-parse --git-dir)
82         mkdir -p "$repo/.git"
83         (
84                 cd "$repo/.git" &&
85                 { cp -Rl "$source_git/objects" . 2>/dev/null ||
86                         cp -R "$source_git/objects" .; } &&
87                 for stuff in "$source_git"/*; do
88                         case "$stuff" in
89                                 */objects|*/hooks|*/config)
90                                         ;;
91                                 *)
92                                         cp -R "$stuff" . || break
93                                         ;;
94                         esac
95                 done &&
96                 cd .. &&
97                 git init -q &&
98                 mv .git/hooks .git/hooks-disabled 2>/dev/null
99         ) || error "failed to copy repository '$source' to '$repo'"
100 }
101
102 # call at least one of these to establish an appropriately-sized repository
103 test_perf_default_repo () {
104         test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_REPO"
105 }
106 test_perf_large_repo () {
107         if test "$GIT_PERF_LARGE_REPO" = "$GIT_BUILD_DIR"; then
108                 echo "warning: \$GIT_PERF_LARGE_REPO is \$GIT_BUILD_DIR." >&2
109                 echo "warning: This will work, but may not be a sufficiently large repo" >&2
110                 echo "warning: for representative measurements." >&2
111         fi
112         test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_LARGE_REPO"
113 }
114 test_checkout_worktree () {
115         git checkout-index -u -a ||
116         error "git checkout-index failed"
117 }
118
119 # Performance tests should never fail.  If they do, stop immediately
120 immediate=t
121
122 test_run_perf_ () {
123         test_cleanup=:
124         test_export_="test_cleanup"
125         export test_cleanup test_export_
126         /usr/bin/time -f "%E %U %S" -o test_time.$i "$SHELL" -c '
127 . '"$TEST_DIRECTORY"/test-lib-functions.sh'
128 test_export () {
129         [ $# != 0 ] || return 0
130         test_export_="$test_export_\\|$1"
131         shift
132         test_export "$@"
133 }
134 '"$1"'
135 ret=$?
136 set | sed -n "s'"/'/'\\\\''/g"';s/^\\($test_export_\\)/export '"'&'"'/p" >test_vars
137 exit $ret' >&3 2>&4
138         eval_ret=$?
139
140         if test $eval_ret = 0 || test -n "$expecting_failure"
141         then
142                 test_eval_ "$test_cleanup"
143                 . ./test_vars || error "failed to load updated environment"
144         fi
145         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
146                 echo ""
147         fi
148         return "$eval_ret"
149 }
150
151
152 test_perf () {
153         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
154         test "$#" = 2 ||
155         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
156         export test_prereq
157         if ! test_skip "$@"
158         then
159                 base=$(basename "$0" .sh)
160                 echo "$test_count" >>"$perf_results_dir"/$base.subtests
161                 echo "$1" >"$perf_results_dir"/$base.$test_count.descr
162                 if test -z "$verbose"; then
163                         echo -n "perf $test_count - $1:"
164                 else
165                         echo "perf $test_count - $1:"
166                 fi
167                 for i in $(test_seq 1 $GIT_PERF_REPEAT_COUNT); do
168                         say >&3 "running: $2"
169                         if test_run_perf_ "$2"
170                         then
171                                 if test -z "$verbose"; then
172                                         echo -n " $i"
173                                 else
174                                         echo "* timing run $i/$GIT_PERF_REPEAT_COUNT:"
175                                 fi
176                         else
177                                 test -z "$verbose" && echo
178                                 test_failure_ "$@"
179                                 break
180                         fi
181                 done
182                 if test -z "$verbose"; then
183                         echo " ok"
184                 else
185                         test_ok_ "$1"
186                 fi
187                 base="$perf_results_dir"/"$perf_results_prefix$(basename "$0" .sh)"."$test_count"
188                 "$TEST_DIRECTORY"/perf/min_time.perl test_time.* >"$base".times
189         fi
190         echo >&3 ""
191 }
192
193 # We extend test_done to print timings at the end (./run disables this
194 # and does it after running everything)
195 test_at_end_hook_ () {
196         if test -z "$GIT_PERF_AGGREGATING_LATER"; then
197                 ( cd "$TEST_DIRECTORY"/perf && ./aggregate.perl $(basename "$0") )
198         fi
199 }
200
201 test_export () {
202         export "$@"
203 }